<?php
//!-- courses --
$db = new PDO('sqlite:db/database.sqlite');

function courses() {
    global $db;

    $statement = $db->query("SELECT * FROM courses");
    return $statement->fetchall();
}
//!-- end courses --

//!-- set_value --
function set_value($name){
    return filter_input(
        INPUT_POST,
        $name,
        FILTER_SANITIZE_SPECIAL_CHARS,
        ['options' => ['default' => '']]);
}
//!-- end set_value --

//!-- compute_error --
function compute_error($form_data,$filters){
    foreach($filters as $key => $filter){
        $data = &$form_data[$key];
        if (
            $data===null ||
            (is_array($data)&&in_array(null,$data,true))
        ){
            return $filter['message'];
        }
    }
    return false;
}
//!-- end compute_error --

function verif($firstname,$lastname,$course) {
    global $db;

    $req = "SELECT count(*) as nb "
            ."FROM students,choices "
            ."where students.id = choices.student_id "
            ."and students.firstname = '".$firstname."' "
            ." and students.lastname = '".$lastname."' "
            ." and choices.course_id = '".$course."' ";
    $rep = $db->query($req);
    $donnee = $rep->fetch(PDO::FETCH_ASSOC);

    if($donnee['nb']){
        return false;
    }

    if ($course === 4){
        $req = "SELECT count(*) as nb "
            ."FROM students,choices "
            ."where students.id = choices.student_id "
            ."and students.firstname = '".$firstname."' "
            ." and students.lastname = '".$lastname."' "
            ." and (choices.course_id = '1' "
            ." or choices.course_id = '2' "
            ." or choices.course_id = '3') ";
        $rep = $db->query($req);
        $donnee = $rep->fetch(PDO::FETCH_ASSOC);

        if($donnee['nb'] != 3){
            return false;
        }
    }
    return true;
}

//!-- register --
function register($firstname,$lastname,$courses) {
    global $db;
    
    $db->beginTransaction();
    $query1='INSERT INTO students(firstname, lastname) VALUES (?, ?)';
    $statement = $db->prepare($query1);
    $success = $statement->execute([$firstname, $lastname]);
    if (!$success) {
        $db->rollback();
        return false;
    }
    $student_id = $db->lastInsertId();

    $query='INSERT INTO choices(student_id, course_id) VALUES (?, ?)';
    $statement = $db->prepare($query);
    foreach ($courses as $course_id) {
       if(verif($firstname, $lastname, $course_id)){
            $success = $statement->execute([$student_id, $course_id]);
            if (!$success) {
                $db->rollback();
                return false;
            }
        }
    }
    $db->commit();
    return true;    
}


function delete_student($firstname,$lastname) {
    global $db;
    $req = "DELETE FROM students "
            ."where students.firstname = '".$firstname."' "
            ." and students.lastname = '".$lastname."' ";
    $db->query($req);
    return true;
}


//!-- end register --
//$var  = $maBD->query('SELECT Reponse FROM FAC WHERE Question="'.$questionfac.'"');
//!-- registrations --
function registrations() {

    $sort = '';
    if(isset($_POST['cours']))
    {
        $sort = "WHERE courses.name='".$_POST['cours']."' ";
    }

    global $db;
    //$cours = 'PHP';
    $query = "SELECT students.firstname,students.lastname,"
           ."group_concat(courses.name, ', ') "
           ."as courses "
           ."FROM students "
           ."LEFT JOIN choices ON students.id = choices.student_id "
           ."LEFT JOIN courses ON choices.course_id = courses.id "
           .$sort
           ."GROUP BY firstname, lastname";
    $statement = $db->query("$query");
    
    return $statement->fetchall();
}
//!-- end registrations --

