<?php
include __DIR__.'/../code/tools.php';
$pathToTemplates= __DIR__."/../templates";

//!-- filtersRC1 --
$filters = [
    'firstname' =>
    [
        'filter' => FILTER_VALIDATE_REGEXP,
        'flags' => FILTER_NULL_ON_FAILURE,
        'options' => ['regexp'=>'/^[A-Za-z\' -]{1,20}$/'],
        'message' => 'Le prénom doit etre alphaNum'
    ],
    'lastname' =>
    //!-- end filtersRC1 --
    [
        'filter' => FILTER_VALIDATE_REGEXP,
        'flags' => FILTER_NULL_ON_FAILURE,
        'options' => ['regexp'=>'/^[A-Za-z\' -]{1,20}$/'],
        'message' => 'Le prénom doit etre alphaNum'
    ],
    //!-- filtersRC2 --
    'courses' => [
        'filter'    => FILTER_VALIDATE_INT,
        'flags'     => FILTER_REQUIRE_ARRAY, 
        'options'   => ['min_range' => 1, 'max_range' => 6],
        'message' => 'Vous devez choisir au moins un cours'
    ]
];

$form_data = filter_input_array(INPUT_POST, $filters, true);
//!-- end filtersRC2 --

//!-- insertRC --
$error = compute_error($form_data, $filters);

if($error!==false) {
    $courses = courses();
    include $pathToTemplates.'/registration_form.html.php';
} else {
    $success = register(
        $form_data['firstname'],
        $form_data['lastname'],
        $form_data['courses']);
    include $success?$pathToTemplates."/success.php":$pathToTemplates."/error.php";
}
//!-- end insertRC --
